use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, conjure_object::private::DeriveWith)]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum SpatialAppearanceColoring {
    MatCap(super::SpatialAppearanceColoringMatCap),
    Solid(super::SpatialAppearanceColoringSolid),
    Geometry(super::SpatialAppearanceColoringGeometry),
    Gradient(super::SpatialAppearanceColoringGradient),
    AttributeRgb(super::SpatialAppearanceColoringAttributeRgb),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for SpatialAppearanceColoring {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            SpatialAppearanceColoring::MatCap(value) => {
                map.serialize_entry(&"type", &"matCap")?;
                map.serialize_entry(&"matCap", value)?;
            }
            SpatialAppearanceColoring::Solid(value) => {
                map.serialize_entry(&"type", &"solid")?;
                map.serialize_entry(&"solid", value)?;
            }
            SpatialAppearanceColoring::Geometry(value) => {
                map.serialize_entry(&"type", &"geometry")?;
                map.serialize_entry(&"geometry", value)?;
            }
            SpatialAppearanceColoring::Gradient(value) => {
                map.serialize_entry(&"type", &"gradient")?;
                map.serialize_entry(&"gradient", value)?;
            }
            SpatialAppearanceColoring::AttributeRgb(value) => {
                map.serialize_entry(&"type", &"attributeRgb")?;
                map.serialize_entry(&"attributeRgb", value)?;
            }
            SpatialAppearanceColoring::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for SpatialAppearanceColoring {
    fn deserialize<D>(d: D) -> Result<SpatialAppearanceColoring, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = SpatialAppearanceColoring;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union SpatialAppearanceColoring")
    }
    fn visit_map<A>(self, mut map: A) -> Result<SpatialAppearanceColoring, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::MatCap, Some(Variant_::MatCap)) => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::MatCap(value)
                    }
                    (Variant_::Solid, Some(Variant_::Solid)) => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::Solid(value)
                    }
                    (Variant_::Geometry, Some(Variant_::Geometry)) => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::Geometry(value)
                    }
                    (Variant_::Gradient, Some(Variant_::Gradient)) => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::Gradient(value)
                    }
                    (Variant_::AttributeRgb, Some(Variant_::AttributeRgb)) => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::AttributeRgb(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            SpatialAppearanceColoring::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::MatCap => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::MatCap(value)
                    }
                    Variant_::Solid => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::Solid(value)
                    }
                    Variant_::Geometry => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::Geometry(value)
                    }
                    Variant_::Gradient => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::Gradient(value)
                    }
                    Variant_::AttributeRgb => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::AttributeRgb(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        SpatialAppearanceColoring::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    MatCap,
    Solid,
    Geometry,
    Gradient,
    AttributeRgb,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::MatCap => "matCap",
            Variant_::Solid => "solid",
            Variant_::Geometry => "geometry",
            Variant_::Gradient => "gradient",
            Variant_::AttributeRgb => "attributeRgb",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "matCap" => Variant_::MatCap,
            "solid" => Variant_::Solid,
            "geometry" => Variant_::Geometry,
            "gradient" => Variant_::Gradient,
            "attributeRgb" => Variant_::AttributeRgb,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the SpatialAppearanceColoring union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
